WITH   Gnat.IO ;  USE Gnat.IO;

PROCEDURE   CharTb31  IS

   L_Code : Integer ;

BEGIN
   ----- LOOP 1
   FOR L_i in 0..15 LOOP

      ----- LOOP 2
      FOR L_j in 0..15 LOOP
         L_Code := L_i*16  +  L_j ;

         ----- Write char  ( Ignoring problem chars )
         IF    (L_Code = 0)  or (L_Code = 7)  or (L_Code = 8) or (L_Code = 9)
            or (L_Code = 10) or (L_Code = 13) or (L_Code = 26)
         THEN
            Put (   "-"   );
         ELSE
            Put (   Character'Val(L_Code)   );
         END IF;
      END LOOP;--j

      New_Line ;
   END LOOP;--i
END;
